module Dezmo_Save_as_DC_name
  extend self
  @@loaded = false unless defined?(@@loaded)
  
  def get_dc_name
    mod = Sketchup.active_model
    sel = mod.selection
    if sel.single_object? && sel.first.respond_to?(:definition)
      name = sel.first.definition.get_attribute("dynamic_attributes", "name")
      def_name = sel.first.definition.name
      return [sel.first.definition, mod.path, name, def_name]
    else
      return [nil,nil,nil,nil]
    end
  end

  def dc_save_as(param, dn = true)
    definition = param[0] 
    path = param[1]
    name = dn ? param[3] : param[2]
    path_name = UI.savepanel("Save DC", path, "#{name}.skp")
    definition.save_as path_name if path_name
  end
  
  unless @@loaded
    cmd1 = UI::Command.new("Save as: DC name"){ dc_save_as(get_dc_name,false) }
    cmd2 = UI::Command.new("Save as: Def name"){ dc_save_as(get_dc_name) }
    cmd1.set_validation_proc {
      if get_dc_name[2]
        MF_ENABLED
      else
        MF_GRAYED | MF_DISABLED
      end
    }
    cmd2.set_validation_proc {
      if get_dc_name[3]
        MF_ENABLED
      else
        MF_GRAYED | MF_DISABLED
      end
    }
    UI.add_context_menu_handler do |context_menu|
      context_menu.add_item(cmd1)
      context_menu.add_item(cmd2)
    end
    @@loaded = true
  end
end